Merge: doc: fixed some typos and other misc. corrections
[nit.git] / misc / jenkins / checkwhitespaces.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 # Check whitespace errors in commits
17 # Usage: checkwhitespaces from to
18 #
19 # This script is in fact a more friendly version of `git log --check`
20
21 set -e
22
23 from=${1:-origin/master}
24 to=${2:-HEAD}
25
26 err=0
27
28 cd `git rev-parse --show-toplevel`
29
30 echo "checkwhitespaces $from (`git rev-parse "$from"`) .. $to (`git rev-parse "$to"`)"
31 for ref in `git rev-list --no-merges "$from".."$to"`; do
32 # Show nothing if no error
33 if git --no-pager show --check --oneline $ref > /dev/null; then
34 continue
35 fi
36
37 # Run the command again to display things
38 echo ""
39 echo "Found whitespace errors in commit"
40 git --no-pager show --check --oneline $ref || true
41 err=1
42 done
43
44 if test "$err" = 1; then
45 echo ""
46 echo "Please check that each file in each commit does not contain whitespace errors."
47 echo "Note that existing commits should be amended; pushing new commit is not sufficient."
48 echo "Hint: use \"git log --check\" to see whitespace errors."
49 fi
50
51 exit $err